;                                   TAB VER
;                     LISTA "TABLE VERSION" per PARADOX 4.0
;                      TABLE VERSION LIST for PARADOX 4.0
;Ŀ
;                     Versione Bivalente Italiano/Inglese                    
;    Questa piccola utility genera la lista delle tabelle nella directory    
;   corrente (+ eventuale dir.privata), e quindi la completa con il numero   
;    di VERSIONE PARADOX (3.5 o 4.0). Ci dovrebbe semplificare il porting   
;   delle applicazioni da Paradox 3.5 a 4.0 - o al limite in senso inverso.  
;   Ricordo che Paradox 4 pu, al momento della ristrutturazione, convertire 
;                le tabelle nel formato nuovo o nel precedente.              
;Rev.Dic.'92: Permette di ristrutturare tutte le tabelle in formato 3.5 o 4. 
;Ĵ
;  This short utility lists the table in the current dir. (+ private dir if  
; any), then inserts the PARADOX VERSION number for each table (3.5 or 4.0). 
;  This should help in converting applications from Paradox 3.5 to 4.0 and   
; viceversa, showing the tables to convert to the new or the previous format 
;                by the means of Modify Restructure command.                 
;  As in Italy we use both English and Italian versions of Paradox, I kept   
;   a script prologue to ensure the 'language independence' of the code.     
; Other Pal programmers outside the States should be able to customize this  
; prologue to their native languages, avoiding the translation with PalTran. 
;     Rev.Dic.'92: Allows you to convert all tables in 3.5 or 4.0 format.    
;Ĵ
;        Guido Salvestroni - CIS # 73527,1132 - Milano, nov/dic. 1992        
;
;------------------------------------------------------------------
PROC TabVerMenu()
   SHOWPULLDOWN
      "ConvertAll" : "Convert All tables to another format"  : "F4"
      SUBMENU
        "35" : "Convert All tables to 3.5 format"  : "F3",
        "40" : "Convert All tables to 4.0 format"  : "F4"
      ENDSUBMENU,
      "Quit"     : "Abandon"  : "Esc"
   ENDMENU
ENDPROC
;------------------------------------------------------------------
PROC PutVer()
  Coeditkey
  Moveto field Name
  SCAN
   [TabVer]=fileversion([]+".DB")
  ENDSCAN
  DO_IT!
ENDPROC
;------------------------------------------------------------------
Proc Si_No(r,c,msg,invio)
        ;,r     ; riga                                                   *
        ;,c     ; colonna                                                *
        ;,msg   ; messaggio showdialog
        ;,invio ; invio necessario o no
        ;... colore S/N selezionato ?
        ; ritorna ESN="Esc/Si/No"

  Proc TastiSN(tipo,tagval,eveval,ele)
    if EVEVAL["TYPE"] = "KEY" then
       switch
         case EVEVAL["KEYCODE"] = 83 or EVEVAL["KEYCODE"] = 115: ;S o s
              sound 500 10 sound 90 20
              ESN="Si"
              SELECTCONTROL "TagSi"
         case EVEVAL["KEYCODE"] = 78 or EVEVAL["KEYCODE"] = 110: ;N o n
              sound 50 20 sound 150 10
              ESN="No"
              SELECTCONTROL "TagNo"
         case EVEVAL["KEYCODE"] = 27: ; Esc
              tagval="Esc"
              ESN="Esc"
              CANCELDIALOG
         otherwise: ESN="X" sound 100 10 return false
       endswitch
       if invio then ACCEPTDIALOG endif
    endif
  EndProc

  SHOWDIALOG msg
   Proc "TastiSN" KEY "S","s","N","n",27
   @r,c height 6 width 60
   ;;@5,2 ?? "Scegli con \026, poi premi Invio"
   Pushbutton @1,05  width 23 "~N~o"
   OK DEFAULT VALUE "No" TAG "TagNo" TO g
   Pushbutton @1,30 width 23 "~S~i"
   OK         VALUE "Si" TAG "TagSi" TO g
  ENDDIALOG
  if isassigned(ESN) then return ESN else return g endif
EndProc
;------------------------------------------------------------------
Proc Restru(S_C)
    Echo Off
    SCAN
     Moveto field Name
     t=[] Message "Converting "+t+" to "+S_C+" format..."
     Menu
     Select Modify
     Select Restructure
     Select t
     Select FileFormat
     Select S_C
     DO_IT!
     if menuchoice()=Convert then select Convert endif
     ClearImage
    ENDSCAN
    Message ""
    Echo Normal
Endproc
;------------------------------------------------------------------
PROC evTrap(TriggerType, EventInfo, CycleNumber)
private eic ; event-info-cs-code
SWITCH
  case EventInfo["TYPE"]="KEY"    : eic=StrKeyCod(EventInfo["KEYCODE"])
  case EventInfo["TYPE"]="MESSAGE" and EventInfo["MESSAGE"]="MENUSELECT":
                                    eic=EventInfo["MENUTAG"]
  otherwise: eic="" ; da vedere
ENDSWITCH

SWITCH ; trattam.opz.menu e shortcuts
     case eic="Esc"  : return 2
     case eic="F3":
           if isempty(table()) then Beep Return 0 endif
           g=SI_NO(16,10, confirm_msg+" 4.0 ?",true)
           if g="Si" then Restru("Compatible") endif
           PutVer()
     case eic="F4":
           if isempty(table()) then Beep Return 0 endif
           g=SI_NO(16,10, confirm_msg+" 3.5 ?",true)
           if g="Si" then Restru("Standard") endif
           PutVer()
     otherwise : SOUND 400 100
ENDSWITCH
RETURN 1
endproc
;------------------------------------------------------------------
Proc SEL_LINGUA() ; prologo SELEZIONE LINGUA - LANGUAGE SELECTION prologue
if upper(substr(pvl,3,1))="I" then
   Ita=true Eng=False         ; ITALIANO
   List="Elenco"
   Quesiti="Quesiti"
   Tools= "Varie"
   Info=  "Mostra"
   Family="Famiglia"
   Inventory="Lista"
   Tables="Tabelle"
   copy!="Duplica"
   JustFamily="Oggetti"
   Modify="Muta"
   Restructure="Ristruttura"
   Answer="Risposta"
   Trimming="Troncamento"
   DifferentTable="AltraTabella"
   Cancel="Annulla"
   Replace!="Sostituisci"
   Name="Nome"
   FileFormat="FileFormat"    ; still to be translated
   Standard="Standard"        ;
   Compatible="Compatible"    ;
   Convert="Convert"
   p0="F10:Menu  Esc:Uscita"
   confirm_msg="CONVERTI TUTTE LE TABELLE AL FORMATO "
 else
   Ita=false Eng=true   ; ENGLISH
   List="List"
   Quesiti="Ask"
   Tools= "Tools"
   Info=  "Info"
   Family="Family"
   Inventory="Inventory"
   Tables="Tables"
   copy!="Copy"
   JustFamily="JustFamily"
   Modify="Modify"
   Restructure="Restructure"
   Answer="Answer"
   Trimming="Trimming"
   DifferentTable="DifferentTable"
   Cancel="Cancel"
   Replace!="Replace"
   Name="Name"
   FileFormat="FileFormat"
   Standard="Standard"
   Compatible="Compatible"
   Convert="Convert"
   p0="F10:Menu  Esc:Abandon"
   confirm_msg="CONVERT ALL TABLES TO FORMAT "
endif
Endproc

; ============================ Main 4TABVER =============================
Clear
Setdir directory()
pvl=strval(int(version()*10))
switch
  case match(
    "CoEditCreateDataEntryEditFormGraphMainPasswordReportRestructureScriptSort",
    ".."+sysmode()+".."): ;Versione inglese
    pvl=pvl+"E"
  case match(
    "CoEditaCreaImmettiEditaSchedaGraficoBaseParolaD'OrdineRapportoRistrutturaProgrammaOrdina",
    ".."+sysmode()+".."): ;Versione italiana
    pvl=pvl+"I"
  otherwise: Quit "LINGUA NON VALIDA - PARADOX LANGUAGE NOT ALLOWED"
endswitch

if upper(substr(pvl,3,1))="I" then
    Message "Un attimo, generazione lista TABLE VERSION"
  else
    Message "Please wait while generating the TABLE VERSION list"
endif
SEL_LINGUA()

;; per test VIEW "LIST" WINMAX
select Tools  select Info  select Inventory  select Tables Enter
select Modify select Restructure Select List
Right Down Ins  "TabVer" Right "A3" Do_It!
Editkey
Moveto field Name
Locate List
if retval then Del endif
DO_IT!
WINMAX
Right
PutVer()
TabVerMenu()

prompt p0
Message ""
Echo Normal
WAIT TABLE
   PROC "evTrap"
   KEY  "F10","Esc"
   MESSAGE "MENUSELECT"
ENDWAIT
prompt ""
Echo Off

ClearAll
